<?php
/**
 * This Software is the property of Data Development and is protected
 * by copyright law - it is NOT Freeware.
 *
 * Any unauthorized use of this software without a valid license
 * is a violation of the license agreement and will be prosecuted by
 * civil and criminal law.
 *
 * http://www.shopmodule.com
 *
 * @copyright (C) D3 Data Development (Inh. Thomas Dartsch)
 * @author    D3 Data Development - Daniel Seifert <ds@shopmodule.com>
 * @link      http://www.oxidmodule.com
 */

class d3tooltipp_update extends d3install_updatebase
{
    public $sModKey = 'd3tooltipp';
    public $sModName = 'Tooltipps';
    public $sModVersion = '2.0.0.4';
    public $sModRevision = '73';
    public $sBaseConf = 'Wy4ak93bFBicWVPTlBjcitXQS9raDIzY3l1Ri9SUjFCNG9aNDlrWVJESHVBWWJCNFNNbWVmZ3dGVEpWb
3NEWjVsMXdXVGZzOG1NUlRLZ3dZT3FGbnNkamJJR3J0dFVpeS9BbkM2Snl2dGMraFc0VExiaGZ6LzVQQ
0NFOHdIRk5JL0pndmIyeEdtQ1NXdUZOV0RKWm54aXREamdQbWtzYzQ2VTJtY2FJS0pEb3N6NEpGamdQU
nA4UmVMQVFtRzcwMFMrNm5TWEIzQVAvdVBobFVMR201QkVYd0FVMGovY0ZXSUJoWmoza0pTakIwMHIyT
FZtTDhFZHZCVW4xck9qOWdRaDVVQnhDN3hQbnMrejgrT0U1STJBeWhjN0lDRWpRRG5FVlFSQ3JIYlNBV
ms9';
    public $sRequirements = '';

    public $sBaseValue = '';

    protected $_aUpdateMethods = array(
        array('check' => 'checkModCfgItemExist',
              'do'    => 'updateModCfgItemExist'),
        array('check' => 'hasOldModuleFiles',
              'do'    => 'deleteOldModuleFiles'),
        array('check' => 'checkModCfgSameRevision',
              'do'    => 'updateModCfgSameRevision'),
    );

    protected $_aRefreshMetaModuleIds = array('d3tooltipp');

    public $aOldModuleFiles = array(
        'd3/d3tooltipp/tooltipp_stub.php',
        'd3/d3tooltipp/models/d3tooltipp_update.php',
        // alte Verzeichnisse (werden zustzlich auf empty geprft, bevor eine Lschung stattfindet)
        'd3/d3tooltipp/models',
    );

    /**
     * @return bool
     */
    public function checkModCfgItemExist()
    {
        $blRet = false;
        foreach ($this->_getShopList() as $oShop)
        {
            /** @var $oShop oxshop */
            $aWhere = array(
                'oxmodid'       => $this->sModKey,
                'oxnewrevision' => $this->sModRevision,
                'oxshopid'      => $oShop->getId(),
            );

            $blRet = $this->_checkTableItemNotExist('d3_cfg_mod', $aWhere);

            if ($blRet)
            {
                return $blRet;
            }
        }

        return $blRet;
    }

    /**
     * @return bool
     */
    public function updateModCfgItemExist()
    {
        $blRet = false;

        if ($this->checkModCfgItemExist())
        {
            foreach ($this->_getShopList() as $oShop)
            {
                /** @var $oShop oxshop */
                $aWhere = array(
                    'oxmodid'       => $this->sModKey,
                    'oxshopid'      => $oShop->getId(),
                    'oxnewrevision' => $this->sModRevision,
                );

                if ($this->_checkTableItemNotExist('d3_cfg_mod', $aWhere))
                {
                    // update don't use this property
                    unset($aWhere['oxnewrevision']);

                    $aInsertFields = array(
                        'OXID'           => array (
                            'content'       => "md5('" . $this->sModKey . " " . $oShop->getId() . " de')",
                            'force_update'  => true,
                            'use_quote'     => false,
                        ),
                        'OXSHOPID'       => array (
                            'content'       => $oShop->getId(),
                            'force_update'  => true,
                            'use_quote'     => true,
                        ),
                        'OXMODID'        => array (
                            'content'       => $this->sModKey,
                            'force_update'  => true,
                            'use_quote'     => true,
                        ),
                        'OXNAME'         => array (
                            'content'       => $this->sModName,
                            'force_update'  => true,
                            'use_quote'     => true,
                        ),
                        'OXACTIVE'       => array (
                            'content'       => "0",
                            'force_update'  => false,
                            'use_quote'     => false,
                        ),
                        'OXBASECONFIG'   => array (
                            'content'       => $this->sBaseConf,
                            'force_update'  => true,
                            'use_quote'     => true,
                        ),
                        'OXSERIAL'   => array (
                            'content'       => "",
                            'force_update'  => false,
                            'use_quote'     => true,
                        ),
                        'OXINSTALLDATE'  => array (
                            'content'       => "NOW()",
                            'force_update'  => true,
                            'use_quote'     => false,
                        ),
                        'OXVERSION'      => array (
                            'content'       => $this->sModVersion,
                            'force_update'  => true,
                            'use_quote'     => true,
                        ),
                        'OXSHOPVERSION'  => array (
                            'content'       => oxRegistry::getConfig()->getEdition(),
                            'force_update'  => true,
                            'use_quote'     => true,
                        ),
                        'OXREQUIREMENTS' => array (
                            'content'       => $this->sRequirements,
                            'force_update'  => true,
                            'use_quote'     => true,
                        ),
                        'OXVALUE'        => array(
                            'content'       => $this->sBaseValue,
                            'force_update'  => false,
                            'use_quote'     => true,
                        ),
                        'OXNEWREVISION'  => array(
                            'content'       => $this->sModRevision,
                            'force_update'  => true,
                            'use_quote'     => true,
                        )
                    );

                    if (method_exists($this, '_updateTableItem2'))
                    {
                        $blRet  = $this->_updateTableItem2('d3_cfg_mod', $aInsertFields, $aWhere);
                    } else {  // bc
                        $aRet  = $this->_updateTableItem('d3_cfg_mod', $aInsertFields, $aWhere);
                        $this->_setActionLog('SQL', $aRet['sql'], __METHOD__);
                        $blRet = $aRet['blRet'];
                        $this->_setUpdateBreak(false);
                    }
                }
            }
        }
        return $blRet;
    }

}
